var xmlhttp;
var stretcher;
var siteID;
var timer;

function loadXMLDoc(url) {
	timer = window.setTimeout("giveUp()", 20000);
	xmlhttp=new XMLHttpRequest();
	xmlhttp.onreadystatechange = xmlhttpChange;
	xmlhttp.open("GET", url, true);
	xmlhttp.send(null);
}

function collegeFootballParse(html) {
	var output = new Array();
	var rows = html.split("\n");
	for(var i in rows) {
		// skip empty
		if(!rows[i] || rows[i].length == 0)
			continue;
		var row = rows[i].split(",");
		output.push(row);
	}
	output.reverse();
	return output;
}

function xmlhttpChange() {
	// if xmlhttp shows "loaded"
	if (xmlhttp.readyState == 4) {
		// if "OK"
		if (xmlhttp.status == 200) {
			var parsedArray = collegeFootballParse(xmlhttp.responseText);
			var filteredArray = filteredCollegeFootballColumns(parsedArray);
			createTable(filteredArray, 250);
			clearTimeout(timer);
		} else {
			giveUp();
		}
	}
}

function giveUp() {
	xmlhttp.abort();
	widget.setPreferenceForKey(0, "lastUpdateTime");
	document.getElementById('winloss').innerText = 'Error: No connection found!';
}

function addHeader(table) {
	// create row
	var row = document.createElement('tr');
	// create columns
	var cols = new Array('Date', 'Opponent', 'Time/Result', 'TV');
	for(var i in cols) {
		var col = document.createElement('th');
		var text = document.createTextNode(cols[i]);
		// build up
		col.appendChild(text);
		row.appendChild(col);
	}
	table.appendChild(row);
}

function addRow(cols, table, index) {
	// create row
	var row = document.createElement('tr');
	// odd rows get alt class
	if(index % 2 == 1)
		row.setAttribute('class', 'alt');
	// add column for each element of row
	for(var i in cols) {
		var col = document.createElement('td');
		var text = document.createTextNode(cols[i]);
		// build up
		col.appendChild(text);
		row.appendChild(col);
	}
	table.appendChild(row);
}

function createTable(rows, width) {
	// create table
	var table = document.createElement('table');
	table.setAttribute('cellpadding', 0);
	table.setAttribute('cellspacing', 0);
	table.setAttribute('border', 0);
	table.setAttribute('width', width);

	// create header
	addHeader(table);

	// create content rows
	for(var row in rows)
		addRow(rows[row], table, row);

	// add to document
	document.getElementById('body').appendChild(table);
	// grow, height is header + content
	var height = parseInt(document.defaultView.getComputedStyle(table, "").getPropertyValue("height"));
	// give us a little padding
	height += 5;
	stretcher = new Stretcher(document.getElementById('body'), height, 300, onStretchFinish);
	stretcher.stretch();
}

// date, opponent, result, record, TV => date, opponent, result/time, TV
function filteredCollegeFootballColumns(array) {
	var result = new Array();

	for(var i in array) {
		var newRow = new Array();
		var oldRow = array[i];

		newRow[0] = oldRow[0];
		newRow[1] = oldRow[1];
		newRow[2] = oldRow[2];
		newRow[3] = oldRow[4];

		result.push(newRow);
	}

	// last non TBA record column is set as winloss
	var winloss = "0 - 0";
	for(var i in array) {
		var row = array[i];
		if(row[3] != "TBA" && row[3] != "Tickets")
			winloss = row[3];
	}
	document.getElementById('winloss').innerText = winloss;

	return result;
}

function getCollegeFootballSchedule() {
	loadXMLDoc("http://widgets.goteamsgo.com/data.php?site=" + siteID + "&format=csv");
}

function loaded(sID) {
	siteID = sID;
	//stretcher = new Stretcher(document.getElementById('body'), height, 300, onStretchFinish);
	getCollegeFootballSchedule();
}

function updateData() {
	// set as loading
	document.getElementById('winloss').innerText = 'Loading...';
	// remove existing table
	var body = document.getElementById('body');
	while(body.childNodes.length)
		body.removeChild(body.childNodes[0]);
	getCollegeFootballSchedule();

	// shrink
	if(stretcher.isStretched())	
		stretcher.stretch();

}

// setup event handlers
if(window.widget) {
	widget.onshow = onShow;
}

// on collapse finish, reload the schedule
function onStretchFinish() {
	//if(!stretcher.isStretched())	
		//getCollegeFootballSchedule();
}

// on show, check preferences for last update time
function onShow() {
	var lastUpdate = widget.preferenceForKey("lastUpdateTime");
	var now = new Date();
	// diff between last update and now
	var diff = now.getTime() - lastUpdate;
	// convert to hours
	diff = diff / 1000 / 60 / 60;
	// if diff >= 4, update
	if(diff >= 4) {
		widget.setPreferenceForKey(now.getTime(), "lastUpdateTime");
		updateData();
	}
	else if(isNaN(lastUpdate))
		widget.setPreferenceForKey(now.getTime(), "lastUpdateTime");
}